{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Alter generator dialog                          }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit altergenerator;

interface

uses Classes, QForms,SysUtils,
  QMask, IBDatabase, IBSQL,ibacconst,
  Qdialogs, QStdCtrls, QControls;

type
  TFAltergenerator = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    EGenerator: TEdit;
    Label2: TLabel;
    EGenValue: TMaskEdit;
    IBSQL1: TIBSQL;
    Trans: TIBTransaction;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    doalter:boolean;
    procedure getgenvalue;
  public
    { Public declarations }
    base:TIBDatabase;
    docreate:boolean;
    procedure Altergen;
  end;

procedure IBDropGenerator(base:TIBDatabase;generator:string);
function IBAlterGenerator(base:TIBDatabase;generator:string):boolean;
function IBNewGenerator(base:TIBDatabase):boolean;

implementation

uses ibutil2;

{$R *.xfm}

function IBAlterGenerator(base:TIBDatabase;generator:string):boolean;
var
 dia:TFAltergenerator;
begin
 dia:=TFAltergenerator.create(Application);
 try
  Dia.base:=base;
  dia.Egenerator.text:=generator;
  dia.getgenvalue;
  dia.ShowModal;
  Result:=dia.docreate;
 finally
  dia.free;
 end;
end;


procedure IBDropGenerator(base:TIBDatabase;generator:string);
begin
 IBExecuteSQL(base,'DELETE FROM RDB$GENERATORS WHERE RDB$GENERATOR_NAME='+QuotedStr(generator));
end;

procedure TFAltergenerator.OKBtnClick(Sender: TObject);
begin
 doalter:=true;
end;

procedure TFAltergenerator.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 try
  if doalter then
   Altergen;
 finally
  doalter:=false;
 end;
end;

procedure TFAltergenerator.Altergen;
var
 astring:string;
 gene:string;
begin
 Trans.defaultdatabase:=base;
 IBSQL1.database:=base;
 Trans.starttransaction;
 try
  gene:=EGenerator.text;
  if base.SQLDialect=3 then
   gene:='"'+gene+'"';
  astring:='SET GENERATOR '+gene+
   ' TO '+EGenValue.text;
  IBSQL1.sql.text:=astring;
  IBSQL1.Execquery;
  Trans.commit;
 except
  Trans.rollback;
  Raise;
 end;
end;

procedure TFAltergenerator.getgenvalue;
var
 astring:string;
 gene:string;
begin
 gene:=EGenerator.text;
 if base.SQLDialect=3 then
  gene:='"'+gene+'"';
 Trans.defaultdatabase:=base;
 IBSQL1.database:=base;
 Trans.starttransaction;
 try
  astring:='SELECT GEN_ID(gene,0) AVALUE FROM RDB$GENERATORS WHERE RDB$GENERATOR_NAME='+
   Quotedstr(EGenerator.text);
  IBSQL1.sql.text:=astring;
  IBSQL1.Execquery;
  try
   if Not IBSQL1.EOF then
   begin
    EGenValue.text:=IntToStr(IBSQL1.Fieldbyname('AVALUE').AsInt64);
   end;
  finally
   IBSQL1.close;
  end;
  Trans.commit;
 except
  Trans.rollback;
  Raise;
 end;
end;

function IBNewGenerator(base:TIBDatabase):boolean;
var
 agen:string;
begin
 result:=false;
 if Inputquery(SRpNewGenerator,SrpGeneratorName,agen) then
 begin
  agen:=Trim(Agen);
  if base.SQLDialect=3 then
   agen:='"'+agen+'"';
  if length(agen)>0 then
  begin
   IBExecuteSQL(base,'CREATE GENERATOR '+agen);
   Result:=true;
  end;
 end;
end;

end.
