{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Database MDI Child form                         }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit databaseform;

interface

uses
  SysUtils, Classes, QForms,
  Db, IBDatabase,QDialogs,
  IBSQL, ibacconst,rpibdb,
  ibutil2,ibacutils,ibexecsql,
  roleaccess, DBClient, QImgList, QActnList, QMenus, QTypes, QStdCtrls,
  QDBCtrls, QGrids, QDBGrids, QExtCtrls, QControls, QComCtrls;

type
  TDatabaseprefsitems=(fedautorefresh,fedsystemdomains,fedsystemdata,fedDetails);
  TDatabaseprefs=set of TDatabaseprefsitems;

  TFDatabase = class(TForm)
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    BNew: TToolButton;
    BOpen: TToolButton;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    IconImages: TImageList;
    ANew: TAction;
    AModify: TAction;
    ADelete: TAction;
    AInfo: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Object1: TMenuItem;
    New1: TMenuItem;
    Modify1: TMenuItem;
    Info1: TMenuItem;
    N1: TMenuItem;
    delete1: TMenuItem;
    N2: TMenuItem;
    Refresh1: TMenuItem;
    ARefresh: TAction;
    ToolButton6: TToolButton;
    DDomains: TClientdataset;
    Trans: TIBTransaction;
    IBCustom: TIBSQL;
    DDomainsFieldName: TStringField;
    DSource: TDataSource;
    ToolButton7: TToolButton;
    ASummary: TAction;
    ADetails: TAction;
    BSummary: TToolButton;
    BDetails: TToolButton;
    Summary1: TMenuItem;
    Details1: TMenuItem;
    DDomainsd: TClientdataset;
    ASystemData: TAction;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    Systemdata1: TMenuItem;
    Display1: TMenuItem;
    DDomainsdFIELDNAME: TStringField;
    DDomainsdDESCRIPTION: TStringField;
    DDomainsdNULLS: TStringField;
    DDomainsdCHECK: TStringField;
    DDomainsdDEFAULT: TStringField;
    DDomainsdCOMPUTED: TStringField;
    DDomainsdCHARACTER_SET: TStringField;
    DDomainsdCOLLATION: TStringField;
    DDomainsdSUBTYPE: TIntegerField;
    DDomainsdSEGSIZE: TIntegerField;
    AAutorefresh: TAction;
    Preferences1: TMenuItem;
    Autorefresh1: TMenuItem;
    DDomainsdSIZEBYTES: TIntegerField;
    ToolButton5: TToolButton;
    ASQL: TAction;
    ToolButton10: TToolButton;
    N3: TMenuItem;
    ExecSQL1: TMenuItem;
    DTables: TClientdataset;
    DTablesTablename: TStringField;
    DTablesD: TClientdataset;
    DTablesdTablename: TStringField;
    DTablesDFieldcount: TIntegerField;
    DTablesDOwner: TStringField;
    DTablesDExternalFile: TStringField;
    DTablesDExternaldescrip: TStringField;
    DViews: TClientdataset;
    DViewsTablename: TStringField;
    DViewsD: TClientdataset;
    DViewsdTablename: TStringField;
    DViewsdFieldcount: TIntegerField;
    DViewsdOwner: TStringField;
    DViewsDSource: TMemoField;
    DStoredd: TClientdataset;
    DStoreddNAME: TStringField;
    DStoreddINPUTCOUNT: TIntegerField;
    DStoreddOUTPUTCOUNT: TIntegerField;
    DStoreddSOURCE: TMemoField;
    DStoreddOWNER: TStringField;
    DStored: TClientdataset;
    DStoredNAME: TStringField;
    DGeneraD: TClientdataset;
    DGeneraDNAME: TStringField;
    DGeneraDVALUE: TLargeintField;
    IBCustom2: TIBSQL;
    DGenera: TClientdataset;
    DGeneraNAME: TStringField;
    DExcept: TClientdataset;
    DExceptd: TClientdataset;
    DExceptNAME: TStringField;
    DExceptdNAME: TStringField;
    DExceptdMESSAGE: TStringField;
    DFunc: TClientdataset;
    DFuncNAME: TStringField;
    DFuncd: TClientdataset;
    DFuncdNAME: TStringField;
    DBlob: TClientdataset;
    DBlobNAME: TStringField;
    DBlobd: TClientdataset;
    DBlobdNAME: TStringField;
    DRoles: TClientdataset;
    DRolesNAME: TStringField;
    DRolesD: TClientdataset;
    DRolesDNAME: TStringField;
    DFuncdMODULE_NAME: TStringField;
    DBlobdMODULE_NAME: TStringField;
    DBlobdENTRYPOINT: TStringField;
    DBlobdINPUT_TYPE: TIntegerField;
    DBlobdOUTPUT_TYPE: TIntegerField;
    DRolesDOWNER_NAME: TStringField;
    DFuncdENTRYPOINT: TStringField;
    ARoleAccess: TAction;
    Securityinformation1: TMenuItem;
    File1: TMenuItem;
    AClose: TAction;
    Closedatabase1: TMenuItem;
    AMetadata: TAction;
    Database1: TMenuItem;
    Extractmetadata1: TMenuItem;
    ScrollBox1: TScrollBox;
    DbGroups: TListView;
    PRight: TPanel;
    Splitsource: TSplitter;
    Label1: TLabel;
    GridGen: TDBGrid;
    DBSource: TDBMemo;
    ASystemdomains: TAction;
    Systemdomains1: TMenuItem;
    procedure AExploreExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DbGroupsSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ASummaryExecute(Sender: TObject);
    procedure ADetailsExecute(Sender: TObject);
    procedure ARefreshExecute(Sender: TObject);
    procedure AInfoExecute(Sender: TObject);
    procedure ADeleteExecute(Sender: TObject);
    procedure AModifyExecute(Sender: TObject);
    procedure ANewExecute(Sender: TObject);
    procedure ASystemDataExecute(Sender: TObject);
    procedure AAutorefreshExecute(Sender: TObject);
    procedure ASQLExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ARoleAccessExecute(Sender: TObject);
    procedure ACloseExecute(Sender: TObject);
    procedure AMetadataExecute(Sender: TObject);
    procedure ASystemdomainsExecute(Sender: TObject);
  private
    { Private declarations }
    FDbase:TIBDatabase;
    FExecSQL: TFExecSQL;
    FRoleAccess:TFRoleAccess;
    procedure Deactivateall;
    procedure ShowDomains;
    procedure ShowTables;
    procedure ShowViews;
    procedure ShowStoreds;
    procedure ShowGenerators;
    procedure ShowExceptions;
    procedure ShowUserFunctions;
    procedure ShowBlobFilters;
    procedure ShowRoles;
    procedure SetDBase(Value:TIBDatabase);
    procedure ActiveDataset(datas:TDataset);
    procedure Filldomaindetail(dia:TFFetching);
    procedure FExecSQLDestroy(Sender:TObject);
    procedure FRoleAccessDestroy(Sender:TObject);
    procedure NewTableform;
    procedure FTableformdestroy(Sender:TObject);
    procedure FTriggerformdestroy(Sender:TObject);
    procedure FProcedureformdestroy(Sender:TObject);
    procedure EditTable(table:string;isview:boolean);
    procedure ReadGenerators(dia:TFFetching);
    procedure ShowRoleOps(role:string);
  public
    { Public declarations }
    server,filename:string;
    username,password,role,charset:string;
    protocol:TrpIBXProtocol;
    tableforms:TStringlist;
    triggerforms:TStringlist;
    procedureforms:TStringlist;
    procedure NewTrigger(tablename:string);
    procedure AlterTrigger(tablename,triggername,source:string;trigtype:integer;tactive:boolean);
    procedure NewProcedure;
    procedure AlterProcedure(procname:string);
    property dbase:TIBDatabase read FDbase write SetDBase;
    property FormExecSQL:TFExecsql read FExecsql;
  end;

var
  FDatabase: TFDatabase;

implementation

uses mainform, ibnewdom, domadvanced, tablenew, tabledepen, newtrigger,
  newview, newstored, altergenerator, newexception, newblobfilter,
  newfunction, metaextract;

{$R *.xfm}

procedure TFDatabase.Deactivateall;
begin
 DDomains.active:=false;
 DDomainsd.active:=false;
 DTables.active:=false;
 Dtablesd.active:=false;
 DViews.active:=false;
 DViewsd.active:=false;
 DStored.active:=false;
 DStoredd.active:=false;
 DGenera.active:=false;
 DGenerad.active:=false;
 DExcept.active:=false;
 DExceptd.active:=false;
 DFunc.active:=false;
 DFuncd.active:=false;
 DBlob.active:=false;
 DBlobd.active:=false;
 DRoles.active:=false;
 DRolesd.active:=false;
end;

procedure TFDatabase.AExploreExecute(Sender: TObject);
begin
 // Shows the explorer window
end;

procedure TFDatabase.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action:=cafree;
 dbase.Free;
end;

procedure TFDatabase.FormCreate(Sender: TObject);
begin
 tableforms:=TStringlist.create;
 triggerforms:=TStringlist.create;
 procedureforms:=TStringlist.create;
 Width:=420;
 Height:=270;
 // Read preferences
 with fmain do
 begin
  if Not (fedautorefresh in databaseprefs) then
   AAutorefresh.Checked:=False;
  if Not (fedsystemdomains in databaseprefs) then
   ASystemdomains.Execute;
  if (feddetails in databaseprefs) then
   ADetails.Checked:=True;
  if (fedsystemdata in databaseprefs) then
  begin
   Self.ASYstemdata.checked:=True;
  end;
 end;
end;

procedure TFDatabase.SetDBase(Value:TIBDatabase);
begin
 FDBase:=Value;
 Trans.DefaultDatabase:=Value;
 IBCustom.Database:=Value;
 IBCustom2.database:=Value;
end;

procedure TFDatabase.DbGroupsSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
 if not assigned(item) then
  exit;
 case Item.index of
  0:
   begin
    AModify.enabled:=True;
    Ainfo.enabled:=true;
    ShowDomains;
   end;
  1:
   begin
    AModify.enabled:=True;
    Ainfo.enabled:=true;
    ShowTables;
   end;
  2:
   begin
    AModify.enabled:=True;
    Ainfo.enabled:=true;
    ShowViews;
   end;
  3:
   begin
    AModify.enabled:=True;
    Ainfo.enabled:=true;
    ShowStoreds;
   end;
  4:
   begin
    AModify.enabled:=True;
    Ainfo.enabled:=False;
    ShowGenerators;
   end;
  5:
   begin
    AModify.enabled:=True;
    Ainfo.enabled:=True;
    ShowExceptions;
   end;
  6:
   begin
    AModify.enabled:=False;
    Ainfo.enabled:=False;
    ShowUserFunctions;
   end;
  7:
   begin
    AModify.enabled:=False;
    Ainfo.enabled:=False;
    ShowBlobFilters;
   end;
   else
   begin
    AModify.enabled:=true;
    Ainfo.enabled:=True;
    ShowRoles;
   end;
 end;
end;

procedure TFDatabase.ActiveDataset(datas:TDataset);
var
 asource:boolean;
begin
 asource:=(datas.FindField('SOURCE')<>nil);
 DBSource.datafield:='';
 DSource.dataset:=datas;
 if asource then
  DBSource.datafield:='SOURCE';
 Gridgen.visible:=True;
 ANew.Enabled:=True;
 if AModify.enabled then
  AModify.Enabled:=Not (Datas.EOF AND Datas.BOF);
 ADelete.enabled:=Not (Datas.EOF AND Datas.BOF);
 ARefresh.enabled:=True;
 if Ainfo.enabled then
  AInfo.enabled:=Not (Datas.EOF AND Datas.BOF);
 if Not ASummary.enabled then
 begin
  ASummary.enabled:=True;
  ADetails.enabled:=True;
 end;
 DBSource.Visible:=asource;
 Splitsource.visible:=asource;
end;

procedure TFDatabase.ShowDomains;
var
 sql:string;
begin
 Helpcontext:=270;
 // Fill with domain names
 if ASummary.checked then
 begin
  if DDomains.Active then
  begin
   Activedataset(DDomains);
   fmain.StatusBar.Panels[0].text:=SRpDomains+':'+FormatFloat('#,#0',DDomains.RecordCount);
   exit;
  end;
  DDomains.Createdataset;
  SQL:='SELECT RDB$FIELD_NAME FROM RDB$FIELDS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE ( (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL) ) ';
  if Not ASystemdomains.checked then
  begin
   if Not ASystemdata.checked then
    SQL:=SQL+' AND '
   else
    SQL:=SQL+' WHERE ';
   SQL:=SQL+' (NOT (RDB$FIELD_NAME LIKE ''RDB$%''))';
  end;
  SQL:=SQL+' ORDER BY RDB$FIELD_NAME';
  ddomains.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DDomains,nil);
   ddomains.first;
  finally
   ddomains.enablecontrols;
  end;
  Activedataset(DDomains);
  fmain.StatusBar.Panels[0].text:=SRpDomains+':'+FormatFloat('#,#0',DDomains.RecordCount);
 end
 else
 begin
  if DDomainsd.Active then
  begin
   Activedataset(DDomainsd);
   fmain.StatusBar.Panels[0].text:=SRpDomains+':'+FormatFloat('#,#0',DDomainsd.RecordCount);
   exit;
  end;
  DDomainsd.Createdataset;
  ExecuteActionProgres(Filldomaindetail,true,nil);
 end;
end;

procedure TFDatabase.Filldomaindetail(dia:TFFetching);
begin
 ddomainsd.disablecontrols;
 try
  Filldatasetwithdomainsinfo(dbase,ASystemData.checked,ASystemDomains.checked,DDomainsd,dia);
  ddomainsd.first;
 finally
  ddomainsd.enablecontrols;
 end;
 Activedataset(DDomainsd);
 fmain.StatusBar.Panels[0].text:=SRpDomains+':'+FormatFloat('#,#0',DDomainsd.RecordCount);
end;

procedure TFDatabase.ShowTables;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DTables.Active then
  begin
   Activedataset(DTables);
   fmain.StatusBar.Panels[0].text:=SRpTables+':'+FormatFloat('#,#0',DTables.RecordCount);
   exit;
  end;
  DTables.Createdataset;
  SQL:='SELECT RDB$RELATION_NAME FROM RDB$RELATIONS ';
  SQL:=SQL+' WHERE (RDB$VIEW_SOURCE IS NULL) ';
  if Not ASystemdata.checked then
   SQL:=SQL+' AND ( (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL) ) ';
  SQL:=SQL+' ORDER BY RDB$RELATION_NAME';
  dtables.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,Dtables,nil);
   dtables.first;
  finally
   dtables.enablecontrols;
  end;
  Activedataset(Dtables);
  fmain.StatusBar.Panels[0].text:=SRpTables+':'+FormatFloat('#,#0',DTables.RecordCount);
 end
 else
 begin
  if DTablesd.Active then
  begin
   Activedataset(DTablesd);
   fmain.StatusBar.Panels[0].text:=SRpTables+':'+FormatFloat('#,#0',DTablesd.RecordCount);
   exit;
  end;
  DTablesd.Createdataset;
  SQL:='SELECT RDB$RELATION_NAME,RDB$FIELD_ID,RDB$OWNER_NAME,RDB$EXTERNAL_FILE,'+
      'RDB$EXTERNAL_DESCRIPTION FROM RDB$RELATIONS ';
  SQL:=SQL+' WHERE (RDB$VIEW_SOURCE IS NULL) ';
  if Not ASystemdata.checked then
   SQL:=SQL+' AND ( (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL) ) ';
  SQL:=SQL+' ORDER BY RDB$RELATION_NAME';
  dtablesd.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,Dtablesd,nil);
   dtablesd.first;
  finally
   dtablesd.enablecontrols;
  end;
  Activedataset(Dtablesd);
  fmain.StatusBar.Panels[0].text:=SRpTables+':'+FormatFloat('#,#0',DTablesd.RecordCount);
 end;
end;

procedure TFDatabase.ShowViews;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DViews.Active then
  begin
   Activedataset(DViews);
   fmain.StatusBar.Panels[0].text:=SRpViews+':'+FormatFloat('#,#0',DViews.RecordCount);
   exit;
  end;
  DViews.Createdataset;
  SQL:='SELECT RDB$RELATION_NAME FROM RDB$RELATIONS ';
  SQL:=SQL+' WHERE (NOT (RDB$VIEW_SOURCE IS NULL)) ';
  if Not ASystemdata.checked then
   SQL:=SQL+' AND ( (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL) ) ';
  SQL:=SQL+' ORDER BY RDB$RELATION_NAME';
  dViews.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DViews,nil);
   dViews.first;
  finally
   dViews.enablecontrols;
  end;
  Activedataset(DViews);
  fmain.StatusBar.Panels[0].text:=SRpViews+':'+FormatFloat('#,#0',DViews.RecordCount);
 end
 else
 begin
  if DViewsd.Active then
  begin
   Activedataset(DViewsd);
   fmain.StatusBar.Panels[0].text:=SRpViews+':'+FormatFloat('#,#0',DViewsd.RecordCount);
   exit;
  end;
  DViewsd.Createdataset;
  SQL:='SELECT RDB$RELATION_NAME,RDB$FIELD_ID,RDB$OWNER_NAME,'+
      'RDB$VIEW_SOURCE FROM RDB$RELATIONS ';
  SQL:=SQL+' WHERE (NOT (RDB$VIEW_SOURCE IS NULL)) ';
  if Not ASystemdata.checked then
   SQL:=SQL+' AND ( (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL) ) ';
  SQL:=SQL+' ORDER BY RDB$RELATION_NAME';
  DViewsD.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DViewsd,nil);
   dViewsd.first;
  finally
   dViewsd.enablecontrols;
  end;
  Activedataset(DViewsd);
  fmain.StatusBar.Panels[0].text:=SRpViews+':'+FormatFloat('#,#0',DViewsd.RecordCount);
 end;
end;

procedure TFDatabase.ShowStoreds;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DStored.Active then
  begin
   Activedataset(DStored);
   fmain.StatusBar.Panels[0].text:=SRpStoreds+':'+FormatFloat('#,#0',DStored.RecordCount);
   exit;
  end;
  DStored.Createdataset;
  SQL:='SELECT RDB$PROCEDURE_NAME FROM RDB$PROCEDURES ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$PROCEDURE_NAME';
  dStored.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DStored,nil);
   dStored.first;
  finally
   dStored.enablecontrols;
  end;
  Activedataset(DStored);
  fmain.StatusBar.Panels[0].text:=SRpStoreds+':'+FormatFloat('#,#0',DStored.RecordCount);
 end
 else
 begin
  if DStoredd.Active then
  begin
   Activedataset(DStoredd);
   fmain.StatusBar.Panels[0].text:=SRpStoreds+':'+FormatFloat('#,#0',DStoredd.RecordCount);
   exit;
  end;
  DStoredd.Createdataset;
  SQL:='SELECT RDB$PROCEDURE_NAME,RDB$PROCEDURE_INPUTS,'+
   'RDB$PROCEDURE_OUTPUTS,RDB$PROCEDURE_SOURCE,'+
   'RDB$OWNER_NAME FROM RDB$PROCEDURES ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$PROCEDURE_NAME';
  DStoredD.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DStoredd,nil);
   dStoredd.first;
  finally
   DStoredd.enablecontrols;
  end;
  Activedataset(DStoredd);
  fmain.StatusBar.Panels[0].text:=SRpStoreds+':'+FormatFloat('#,#0',DStoredd.RecordCount);
 end;
end;


procedure TFDatabase.ReadGenerators(dia:TFFetching);
var
 SQL:string;
begin
 SQL:='SELECT RDB$GENERATOR_NAME FROM RDB$GENERATORS ';
 if Not ASystemdata.checked then
  SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
 SQL:=SQL+' ORDER BY RDB$GENERATOR_NAME';
 DGeneraD.disablecontrols;
 try
  Trans.starttransaction;
  try
   IBCustom.SQL.text:=sql;
   IBCustom.Execquery;
   try
    dia.incfetch(1);
    While Not IBCustom.EOF do
    begin
     DGenerad.append;
     try
      DGeneraDName.value:=IBCustom.fieldbyname('RDB$GENERATOR_NAME').asstring;
      if (dbase.SQLDialect=3) then
       IBCustom2.sql.text:='SELECT GEN_ID("'+
        dgeneradname.value+'",0) AVALUE '+
        ' FROM RDB$GENERATORS WHERE RDB$GENERATOR_NAME='+
        QuotedSTr(dgeneradname.value)
      else
       IBCustom2.sql.text:='SELECT GEN_ID('+
        dgeneradname.value+',0) AVALUE '+
        ' FROM RDB$GENERATORS WHERE RDB$GENERATOR_NAME='+
        QuotedSTr(dgeneradname.value);
      IBCustom2.ExecQuery;
      try
       if Not IBCustom2.EOF then
       begin
        DGeneraDValue.value:=IBCustom2.fieldbyname('AVALUE').AsInt64;
       end;
      finally
       IBCustom2.close;
      end;
      DGenerad.post;
     except
      DGenerad.cancel;
      raise;
     end;
     IBCustom.next;
     dia.incfetch(1);
    end;
   finally
    IBCustom.close;
   end;
  finally
   Trans.rollback;
  end;
  DGenerad.first;
 finally
  DGenerad.enablecontrols;
 end;
end;

procedure TFDatabase.ShowGenerators;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DGenera.Active then
  begin
   Activedataset(DGenera);
   fmain.StatusBar.Panels[0].text:=SRpGenerators+':'+FormatFloat('#,#0',DGenera.RecordCount);
   exit;
  end;
  DGenera.CreateDataset;
  SQL:='SELECT RDB$GENERATOR_NAME FROM RDB$GENERATORS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$GENERATOR_NAME';
  DGenera.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DGenera,nil);
   DGenera.first;
  finally
   dGenera.enablecontrols;
  end;
  Activedataset(DGenera);
  fmain.StatusBar.Panels[0].text:=SRpGenerators+':'+FormatFloat('#,#0',DGenera.RecordCount);
 end
 else
 begin
  if DGenerad.Active then
  begin
   Activedataset(DGenerad);
   fmain.StatusBar.Panels[0].text:=SRpGenerators+':'+FormatFloat('#,#0',DGenerad.RecordCount);
   exit;
  end;
  DGenerad.CreateDataset;
  Executeactionprogres(ReadGenerators,true,nil);
  Activedataset(DGenerad);
  fmain.StatusBar.Panels[0].text:=SRpGenerators+':'+FormatFloat('#,#0',DGenerad.RecordCount);
 end;
end;

procedure TFDatabase.ShowExceptions;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DExcept.Active then
  begin
   Activedataset(DExcept);
   fmain.StatusBar.Panels[0].text:=SRpExceptions+':'+FormatFloat('#,#0',DExcept.RecordCount);
   exit;
  end;
  DExcept.Createdataset;
  SQL:='SELECT RDB$EXCEPTION_NAME FROM RDB$EXCEPTIONS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$EXCEPTION_NAME';
  dExcept.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DExcept,nil);
   dExcept.first;
  finally
   dExcept.enablecontrols;
  end;
  Activedataset(DExcept);
  fmain.StatusBar.Panels[0].text:=SRpExceptions+':'+FormatFloat('#,#0',DExcept.RecordCount);
 end
 else
 begin
  if DExceptd.Active then
  begin
   Activedataset(DExceptd);
   fmain.StatusBar.Panels[0].text:=SRpExceptions+':'+FormatFloat('#,#0',DExceptd.RecordCount);
   exit;
  end;
  DExceptd.Createdataset;
  SQL:='SELECT RDB$EXCEPTION_NAME,RDB$MESSAGE '+
   ' FROM RDB$EXCEPTIONS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$EXCEPTION_NAME';
  DExceptd.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DExceptd,nil);
   dExceptd.first;
  finally
   DExceptd.enablecontrols;
  end;
  Activedataset(DExceptd);
  fmain.StatusBar.Panels[0].text:=SRpExceptions+':'+FormatFloat('#,#0',DExceptd.RecordCount);
 end;
end;

procedure TFDatabase.ShowUserFunctions;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DFunc.Active then
  begin
   Activedataset(DFunc);
   fmain.StatusBar.Panels[0].text:=SRpUserfunctions+':'+FormatFloat('#,#0',DFunc.RecordCount);
   exit;
  end;
  DFunc.Createdataset;
  SQL:='SELECT RDB$FUNCTION_NAME FROM RDB$FUNCTIONS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$FUNCTION_NAME';
  dFunc.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DFunc,nil);
   dFunc.first;
  finally
   dFunc.enablecontrols;
  end;
  Activedataset(DFunc);
  fmain.StatusBar.Panels[0].text:=SRpUserfunctions+':'+FormatFloat('#,#0',DFunc.RecordCount);
 end
 else
 begin
  if DFuncd.Active then
  begin
   Activedataset(DFuncd);
   fmain.StatusBar.Panels[0].text:=SRpUserfunctions+':'+FormatFloat('#,#0',DFuncd.RecordCount);
   exit;
  end;
  DFuncd.Createdataset;
  SQL:='SELECT RDB$FUNCTION_NAME,RDB$MODULE_NAME,RDB$ENTRYPOINT '+
   ' FROM RDB$FUNCTIONS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$FUNCTION_NAME';
  DFuncd.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DFuncd,nil);
   dFuncd.first;
  finally
   DFuncd.enablecontrols;
  end;
  Activedataset(DFuncd);
  fmain.StatusBar.Panels[0].text:=SRpUserfunctions+':'+FormatFloat('#,#0',DFuncd.RecordCount);
 end;
end;

procedure TFDatabase.ShowBlobFilters;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DBlob.Active then
  begin
   Activedataset(DBlob);
   fmain.StatusBar.Panels[0].text:=SRpBlobFilters+':'+FormatFloat('#,#0',DBlob.RecordCount);
   exit;
  end;
  DBlob.Createdataset;
  SQL:='SELECT RDB$FUNCTION_NAME FROM RDB$FILTERS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$FUNCTION_NAME';
  dBlob.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DBlob,nil);
   dBlob.first;
  finally
   DBlob.enablecontrols;
  end;
  Activedataset(DBlob);
  fmain.StatusBar.Panels[0].text:=SRpBlobFilters+':'+FormatFloat('#,#0',DBlob.RecordCount);
 end
 else
 begin
  if DBlobd.Active then
  begin
   Activedataset(DBlobd);
   fmain.StatusBar.Panels[0].text:=SRpBlobFilters+':'+FormatFloat('#,#0',DBlobd.RecordCount);
   exit;
  end;
  DBlobd.Createdataset;
  SQL:='SELECT RDB$FUNCTION_NAME,RDB$MODULE_NAME, '+
   'RDB$ENTRYPOINT,RDB$INPUT_SUB_TYPE,RDB$OUTPUT_SUB_TYPE'+
   ' FROM RDB$FILTERS ';
  if Not ASystemdata.checked then
   SQL:=SQL+' WHERE (RDB$SYSTEM_FLAG=0) or (RDB$SYSTEM_FLAG IS NULL)';
  SQL:=SQL+' ORDER BY RDB$FUNCTION_NAME';
  DBlobd.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DBlobd,nil);
   DBlobd.first;
  finally
   DBlobd.enablecontrols;
  end;
  Activedataset(DBlobd);
  fmain.StatusBar.Panels[0].text:=SRpBlobFilters+':'+FormatFloat('#,#0',DBlobd.RecordCount);
 end;
end;

procedure TFDatabase.ShowRoles;
var
 sql:string;
begin
 // Fill with table names
 if ASummary.checked then
 begin
  if DRoles.Active then
  begin
   Activedataset(DRoles);
   fmain.StatusBar.Panels[0].text:=SRpRoles+':'+FormatFloat('#,#0',DRoles.RecordCount);
   exit;
  end;
  DRoles.Createdataset;
  SQL:='SELECT RDB$ROLE_NAME FROM RDB$ROLES ';
  SQL:=SQL+' ORDER BY RDB$ROLE_NAME';
  dRoles.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DRoles,nil);
   dRoles.first;
  finally
   DRoles.enablecontrols;
  end;
  Activedataset(DRoles);
  fmain.StatusBar.Panels[0].text:=SRpRoles+':'+FormatFloat('#,#0',DRoles.RecordCount);
 end
 else
 begin
  if DRolesd.Active then
  begin
   Activedataset(DRolesd);
   fmain.StatusBar.Panels[0].text:=SRpRoles+':'+FormatFloat('#,#0',DRolesd.RecordCount);
   exit;
  end;
  DRolesd.CreateDataset;
  SQL:='SELECT RDB$ROLE_NAME,RDB$OWNER_NAME '+   ' FROM RDB$ROLES ';
  SQL:=SQL+' ORDER BY RDB$ROLE_NAME';
  DRolesd.disablecontrols;
  try
   FillDataset(IBCustom,Trans,SQL,DRolesd,nil);
   DRolesd.first;
  finally
   DRolesd.enablecontrols;
  end;
  Activedataset(DRolesd);
  fmain.StatusBar.Panels[0].text:=SRpRoles+':'+FormatFloat('#,#0',DRolesd.RecordCount);
 end;
end;


procedure TFDatabase.ASummaryExecute(Sender: TObject);
begin
 ASummary.checked:=True;
 ADetails.checked:=FalsE;
 ARefreshExecute(self);
end;

procedure TFDatabase.ADetailsExecute(Sender: TObject);
begin
 ADetails.checked:=True;
 ASummary.checked:=False;
 Deactivateall;
 ARefreshExecute(self);
end;

procedure TFDatabase.ARefreshExecute(Sender: TObject);
var
 old:String;
 olddataset:TDataSet;
begin
 if Not assigned(dbgroups.selected) then
  exit;
 old:='';
 olddataset:=nil;
 // Refresh the active data
 case DBGroups.Selected.index of
   0:
    begin
     if DDomains.active then
     begin
      old:=DDomainsFIELDNAME.AsString;
      olddataset:=DDomains;
     end;
     if DDomainsd.active then
     begin
      old:=DDomainsdFIELDNAME.AsString;
      olddataset:=DDomainsd;
     end;
     DDomains.Active:=False;
     DDomainsd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('FIELDNAME',old,[]);
    end;
   1:
    begin
     if DTables.active then
     begin
      old:=DTablesTableName.AsString;
      olddataset:=DTables;
     end;
     if DTablesd.active then
     begin
      old:=DTablesdTablename.AsString;
      olddataset:=DTablesD;
     end;
     DTables.Active:=False;
     DTablesd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('TABLENAME',old,[]);
    end;
   2:
    begin
     if DViews.active then
     begin
      old:=DViewsTableName.AsString;
      olddataset:=DViews;
     end;
     if DViewsd.active then
     begin
      old:=DViewsdTablename.AsString;
      olddataset:=DViewsD;
     end;
     DViews.Active:=False;
     DViewsd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('TABLENAME',old,[]);
    end;
   3:
    begin
     if DStored.active then
     begin
      old:=DStoredName.AsString;
      olddataset:=DStored;
     end;
     if DStoredd.active then
     begin
      old:=DStoreddName.AsString;
      olddataset:=DStoredD;
     end;
     DStored.Active:=False;
     DStoredd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('NAME',old,[]);
    end;
   4:
    begin
     if DGenera.active then
     begin
      old:=DGeneraName.AsString;
      olddataset:=DGenera;
     end;
     if DGenerad.active then
     begin
      old:=DGeneradName.AsString;
      olddataset:=DGeneraD;
     end;
     DGenera.Active:=False;
     DGenerad.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('NAME',old,[]);
    end;
   5:
    begin
     if DExcept.active then
     begin
      old:=DExceptName.AsString;
      olddataset:=DExcept;
     end;
     if DExceptd.active then
     begin
      old:=DExceptdName.AsString;
      olddataset:=DExceptD;
     end;
     DExcept.Active:=False;
     DExceptd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('NAME',old,[]);
    end;
   6:
    begin
     if DFunc.active then
     begin
      old:=DFuncName.AsString;
      olddataset:=DFunc;
     end;
     if DFuncd.active then
     begin
      old:=DFuncdName.AsString;
      olddataset:=DFuncD;
     end;
     DFunc.Active:=False;
     DFuncd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('NAME',old,[]);
    end;
   7:
    begin
     if DBlob.active then
     begin
      old:=DBlobName.AsString;
      olddataset:=DBlob;
     end;
     if DBlobd.active then
     begin
      old:=DBlobdName.AsString;
      olddataset:=DBlobD;
     end;
     DBlob.Active:=False;
     DBlobd.Active:=False;
     DbGroupsSelectItem(self,dbgroups.selected,True);
     if assigned(olddataset) then
      if (olddataset.active) then
       olddataset.locate('NAME',old,[]);
    end;
  else
  begin
   if DRoles.active then
   begin
    old:=DRolesName.AsString;
    olddataset:=DRoles;
   end;
   if DRolesd.active then
   begin
    old:=DRolesName.AsString;
    olddataset:=DRolesD;
   end;
   DRoles.Active:=False;
   DRolesd.Active:=False;
   DbGroupsSelectItem(self,dbgroups.selected,True);
   if assigned(olddataset) then
    if (olddataset.active) then
     olddataset.locate('NAME',old,[]);
  end;
 end;
end;

procedure TFDatabase.AInfoExecute(Sender: TObject);
begin
 // Shows detailed info
 if Not assigned(dbgroups.selected) then
  exit;
 // Refresh the active data
 case DBGroups.Selected.index of
   0:
    begin
     // show domain info
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowdomain(dbase,dsource.dataset.fieldbyname('FIELDNAME').AsString);
      end;
     end;
    end;
   1:
    begin
     // show table info
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowtabledepen(dbase,dsource.dataset.fieldbyname('TABLENAME').AsString,depentable);
      end;
     end;
    end;
   2:
    begin
     // show view info
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowtabledepen(dbase,dsource.dataset.fieldbyname('TABLENAME').AsString,depenview);
      end;
     end;
    end;
   3:
    begin
     // show stored info
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowtabledepen(dbase,dsource.dataset.fieldbyname('NAME').AsString,depenproc);
      end;
     end;
    end;
   4:
    begin
     // show generator info
{     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowtabledepen(dbase,dsource.dataset.fieldbyname('NAME').AsString,depenproc);
      end;
     end;
}    end;
   5:
    begin
     // show exception info
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowtabledepen(dbase,dsource.dataset.fieldbyname('NAME').AsString,depenproc);
      end;
     end;
    end;
   6:
    begin
    end;
   7:
    begin
     //ShowBlobFilters;
    end;
 else
  begin
     // show role info
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibshowtabledepen(dbase,dsource.dataset.fieldbyname('NAME').AsString,depenproc);
      end;
     end;
  end;
 end;
end;

procedure TFDatabase.ADeleteExecute(Sender: TObject);
begin
 // Deletes the active object
 // New object
 if Not assigned(dbgroups.selected) then
  exit;
 // Refresh the active data
 case DBGroups.Selected.index of
   0:
    begin
     // delete domain
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibdropdomain(dbase,dsource.dataset.fieldbyname('FIELDNAME').AsString);
       if AAutorefresh.checked then
        ArefreshExecute(self);
      end;
     end;
    end;
   1:
    begin
     // delete table
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if mrYes=MessageDlg(Format(SRpDelTable,
        [dsource.dataset.fieldbyname('TABLENAME').AsString]),mtwarning,[mbyes,mbno,mbcancel],0) then
       begin
        ibdroptable(dbase,dsource.dataset.fieldbyname('TABLENAME').AsString);
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   2:
    begin
     // delete view
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if mrYes=MessageDlg(Format(SRpDelView,
        [dsource.dataset.fieldbyname('TABLENAME').AsString]),mtwarning,[mbyes,mbno,mbcancel],0) then
       begin
        ibdropview(dbase,dsource.dataset.fieldbyname('TABLENAME').AsString);
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   3:
    begin
     // delete stored procedure
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if mrYes=MessageDlg(Format(SRpDelProc,
        [dsource.dataset.fieldbyname('NAME').AsString]),mtwarning,[mbyes,mbno,mbcancel],0) then
       begin
        ibdropstored(dbase,dsource.dataset.fieldbyname('NAME').AsString);
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   4:
    begin
     // delete generator
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if mrYes=MessageDlg(Format(SRpDelGenerator,
        [dsource.dataset.fieldbyname('NAME').AsString]),mtwarning,[mbyes,mbno,mbcancel],0) then
       begin
        ibdropgenerator(dbase,dsource.dataset.fieldbyname('NAME').AsString);
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   5:
    begin
     // delete exception
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibdropexception(dbase,dsource.dataset.fieldbyname('NAME').AsString);
       if AAutorefresh.checked then
        ArefreshExecute(self);
      end;
     end;
    end;
   6:
    begin
     // delete function
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibdropfunction(dbase,dsource.dataset.fieldbyname('NAME').AsString);
       if AAutorefresh.checked then
        ArefreshExecute(self);
      end;
     end;
    end;
   7:
    begin
     // delete blob filter
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       ibdropblobfilter(dbase,dsource.dataset.fieldbyname('NAME').AsString);
       if AAutorefresh.checked then
        ArefreshExecute(self);
      end;
     end;
    end;
 else
  begin
   // delete role
   if Assigned(DSource.dataset) then
   begin
    if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
    begin
     if (dbase.SQLDialect=3) then
      IBExecuteSQL(dbase,'DROP ROLE "'+dsource.dataset.fieldbyname('NAME').AsString+'"')
     else
      IBExecuteSQL(dbase,'DROP ROLE '+dsource.dataset.fieldbyname('NAME').AsString);
     if AAutorefresh.checked then
      ArefreshExecute(self);
    end;
   end;
  end;
 end;
end;

procedure TFDatabase.AModifyExecute(Sender: TObject);
begin
 // Modify the active object
 // Deletes the active object
 // New object
 if Not assigned(dbgroups.selected) then
  exit;
 // Refresh the active data
 case DBGroups.Selected.index of
   0:
    begin
     // modify domain
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if ibmodifydomain(dbase,trim(dsource.dataset.fieldbyname('FIELDNAME').AsString)) then
       begin
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   1:
    begin
     // modify table
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       EditTable(dsource.dataset.fieldbyname('TABLENAME').AsString,false);
      end;
     end;
    end;
   2:
    begin
     // modify view
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       EditTable(dsource.dataset.fieldbyname('TABLENAME').AsString,true);
      end;
     end;
    end;
   3:
    begin
     // modify procedure
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       AlterProcedure(dsource.dataset.fieldbyname('NAME').AsString);
      end;
     end;
    end;
   4:
    begin
     // modify generator
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if ibaltergenerator(dbase,dsource.dataset.fieldbyname('NAME').AsString) then
       begin
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   5:
    begin
     // modify exception
     if Assigned(DSource.dataset) then
     begin
      if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
      begin
       if ibalterexception(dbase,dsource.dataset.fieldbyname('NAME').AsString) then
       begin
        if AAutorefresh.checked then
         ArefreshExecute(self);
       end;
      end;
     end;
    end;
   6:
    begin
    //ShowUserFunctions;
    end;
   7:
    begin
    //ShowBlobFilters;
    end;
 else
  begin
   // Modify Roles
   if Assigned(DSource.dataset) then
   begin
    if (Not (DSource.dataset.EOF AND DSource.dataset.BOF)) then
    begin
     Showroleops(DSource.dataset.FieldByName('NAME').AsString);
    end;
   end;
  end;
 end;
end;

procedure TFDatabase.ANewExecute(Sender: TObject);
var
 arole:string;
begin
 // New object
 if Not assigned(dbgroups.selected) then
  exit;
 // Refresh the active data
 case DBGroups.Selected.index of
   0:
    begin
     // New domain
     ibnewdomain(dbase,'Newdomain');
     if AAutorefresh.checked then
      ArefreshExecute(self);
    end;
   1:
    begin
     NewTableform;
    end;
   2:
    begin
     if IBCreateView(dbase) then
     begin
      if AAutorefresh.checked then
       ArefreshExecute(self);
     end;
    end;
   3:
    begin
     NewProcedure;
    end;
   4:
    begin
     if IBNewgenerator(dbase) then
     begin
      if AAutorefresh.checked then
       ArefreshExecute(self);
     end;
    end;
   5:
    begin
     if IBNewException(dbase) then
     begin
      if AAutorefresh.checked then
       ArefreshExecute(self);
     end;
    end;
   6:
    begin
     if IBNewFunction(dbase) then
     begin
      if AAutorefresh.checked then
       ArefreshExecute(self);
     end;
    end;
   7:
    begin
     if IBNewBlobFilter(dbase) then
     begin
      if AAutorefresh.checked then
       ArefreshExecute(self);
     end;
    end;
 else
  begin
   arole:='NEWUSERROLE';
   if InputQuery(SRpNewRole,SrpRolename,arole) then
   begin
    IBExecuteSQL(dbase,'CREATE ROLE '+arole);
    if AAutorefresh.checked then
     ArefreshExecute(self);
   end;
  end;
 end;
end;

procedure TFDatabase.ASystemDataExecute(Sender: TObject);
begin
 ASystemdata.checked:=Not ASystemdata.checked;
 Deactivateall;
 ARefreshexecute(Self);
end;

procedure TFDatabase.AAutorefreshExecute(Sender: TObject);
begin
 AAutorefresh.checked:=Not AAutorefresh.checked;
end;

procedure TFDatabase.FExecSQLDestroy(Sender:TObject);
begin
 FExecSQL:=nil;
end;

procedure TFDatabase.FRoleAccessDestroy(Sender:TObject);
begin
 FRoleAccess:=nil;
end;

procedure TFDatabase.ASQLExecute(Sender: TObject);
begin
 if Assigned(FExecSQL) then
  FExecSQL.Show
 else
 begin
  Application.CreateForm(TFExecSQL,FExecSQL);
  fmain.DWindows.AppendRecord(
  [SRpExecSQL,
   SrpWindow,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(FExecSQL)]);
  FExecSQL.base:=dbase;
  FExecSQL.OnDestroy:=FExecSQLDestroy;
  FExecSQL.Trans.DefaultDatabase:=dbase;
  FExecSQL.Caption:=SrpExecSQL+' - '+dbase.DatabaseName;
  FExecSQL.LoadHistory;
 end;
end;

procedure TFDatabase.FormDestroy(Sender: TObject);
var
 index:integer;
begin
 tableforms.free;
 triggerforms.free;
 procedureforms.free;
 // Insert into mainform database list
 index:=fmain.dblist.indexofobject(dbase);
 if index>=0 then
  FMain.dblist.Delete(index);
 // Destroy the reference in fMain
 if fmain.DWindows.Locate('WINDOW',integer(Self),[]) then
  fmain.DWindows.delete;
end;

procedure TFDatabase.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
 acount:integer;
begin
 if Assigned(FExecsql) then
 begin
  FExecSQL.Close;
  if FExecsql.isdestroying then
   FExecSQL:=nil;
 end;
 if Assigned(FRoleAccess) then
 begin
  FRoleAccess.Close;
  if FRoleAccess.isdestroying then
   FRoleAccess:=nil;
 end;
 if assigned(FExecSQL) then
 begin
  Canclose:=false;
  exit;
 end;
 // Close all table forms
 While tableforms.count>0 do
 begin
  acount:=tableforms.count;
  TForm(tableforms.objects[0]).close;
  if tableforms.count=acount then
  begin
   if (Not TFTableNew(tableforms.objects[0]).isdestroying) then
   begin
    canclose:=false;
    exit;
   end
   else
    tableforms.delete(0);
  end;
 end;
 // Close all trigger forms
 While triggerforms.count>0 do
 begin
  acount:=triggerforms.count;
  TForm(triggerforms.objects[0]).close;
  if triggerforms.count=acount then
  begin
   if (Not TFNewTrigger(triggerforms.objects[0]).isdestroying) then
   begin
    canclose:=false;
    exit;
   end
   else
    triggerforms.delete(0);
  end;
 end;

 While procedureforms.count>0 do
 begin
  acount:=procedureforms.count;
  TForm(procedureforms.objects[0]).close;
  if procedureforms.count=acount then
  begin
   if (Not TFNewStored(procedureforms.objects[0]).isdestroying) then
   begin
    canclose:=false;
    exit;
   end
   else
    procedureforms.delete(0);
  end;
 end;


end;

procedure TFDatabase.EditTable(table:string;isview:boolean);
var
 tnew:TFTablenew;
 index:integer;
begin
 // Watch if it's created
 index:=tableforms.indexof(table);
 if index>=0 then
 begin
  TForm(tableforms.objects[index]).Show;
  exit;
 end;
 Application.CreateForm(TFTablenew,tnew);
 fmain.DWindows.AppendRecord(
  [table,
   SRpTable,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(tnew)]);
 tableforms.addobject(table,tnew);
 tnew.isview:=isview;
 tnew.dbform:=self;
 tnew.table:=table;
 if isview then
  tnew.caption:=SRpView+':'+table+' - '+dbase.databasename
 else
  tnew.caption:=SRpTable+':'+table+' - '+dbase.databasename;
 tnew.ondestroy:=FTableformdestroy;
 tnew.forcreate:=False;
 tnew.base:=dbase;
end;

procedure TFDatabase.NewTableform;
var
 tnew:TFTablenew;
begin
 Application.CreateForm(TFTablenew,tnew);
 fmain.DWindows.AppendRecord(
  [Srptablenew,
   SRpTable,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(TNew)]);
 tnew.dbform:=self;
 tableforms.addobject('',tnew);
 tnew.ondestroy:=FTableformdestroy;
 tnew.caption:=SRpNewTable+' - '+dbase.databasename;
 tnew.table:='NEWTABLE';
 tnew.forcreate:=true;
 tnew.base:=dbase;
end;

procedure TFDatabase.FTableformdestroy(Sender:TObject);
var
 index:integer;
begin
 index:=tableforms.indexofobject(Sender);
 if index>=0 then
  tableforms.delete(index);
end;

procedure TFDatabase.FTriggerformdestroy(Sender:TObject);
var
 index:integer;
begin
 index:=triggerforms.indexofobject(Sender);
 if index>=0 then
  triggerforms.delete(index);
end;

procedure TFDatabase.FProcedureformdestroy(Sender:TObject);
var
 index:integer;
begin
 index:=procedureforms.indexofobject(Sender);
 if index>=0 then
  procedureforms.delete(index);
end;

procedure TFDatabase.NewTrigger(tablename:string);
var
 tnew:TFNewTrigger;
begin
 Application.CreateForm(TFNewTrigger,tnew);
 fmain.DWindows.AppendRecord(
  [SRpnewtrigger,
   SRpTrigger,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(tnew)]);
 triggerforms.addobject('',tnew);
 tnew.ondestroy:=FTriggerformdestroy;
 tnew.caption:=SRpNewTrigger+' - '+dbase.databasename;
 tnew.CheckActive.checked:=True;
 tnew.ETable.text:=tablename;
 tnew.base:=dbase;
 tnew.dbform:=self;
 tnew.forcreate:=True;
 tnew.acompile.enabled:=false;
 tnew.base:=dbase;
end;

procedure TFDatabase.AlterTrigger(tablename,triggername,source:string;trigtype:integer;tactive:boolean);
var
 tnew:TFNewTrigger;
 index:integer;
begin
 // Watch if it's created
 index:=triggerforms.indexof(triggername);
 if index>=0 then
 begin
  TForm(triggerforms.objects[index]).Show;
  exit;
 end;
 Application.CreateForm(TFNewTrigger,tnew);
 fmain.DWindows.AppendRecord(
  [triggername,
   SRpTrigger,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(tnew)]);
 triggerforms.addobject(triggername,tnew);
 tnew.ondestroy:=FTriggerformdestroy;
 tnew.CheckActive.checked:=tactive;
 tnew.ETable.text:=tablename;
 tnew.TrigEdit.text:=source;
 tnew.base:=dbase;
 tnew.ETriggername.text:=triggername;
 tnew.ComboType.Itemindex:=trigtype-1;
 tnew.caption:=SRpTrigger+':'+triggername+' - '+dbase.databasename;
 tnew.dbform:=self;
 tnew.forcreate:=false;
 tnew.acompile.enabled:=false;
 tnew.base:=dbase;
end;

procedure TFDatabase.NewProcedure;
var
 tnew:TFNewStored;
begin
 Application.CreateForm(TFNewStored,tnew);
 fmain.DWindows.AppendRecord(
  [SRpnewprocedure,
   SRpProcedure,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(TNew)]);
 procedureforms.addobject('',tnew);
 tnew.ondestroy:=Fprocedureformdestroy;
 tnew.caption:=SRpNewProcedure+' - '+dbase.databasename;
 tnew.base:=dbase;
 tnew.dbform:=self;
 tnew.forcreate:=True;
 tnew.acompile.enabled:=false;
 tnew.aexecute.enabled:=False;
end;

procedure TFDatabase.AlterProcedure(procname:string);
var
 tnew:TFNewstored;
 index:integer;
begin
 // Watch if it's created
 index:=procedureforms.indexof(procname);
 if index>=0 then
 begin
  TForm(procedureforms.objects[index]).Show;
  exit;
 end;
 Application.CreateForm(TFNewStored,tnew);
 fmain.DWindows.AppendRecord(
  [procname,
   SRpProcedure,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(TNew)]);
 procedureforms.addobject(procname,tnew);
 tnew.ondestroy:=FProcedureformdestroy;
 tnew.Eprocedurename.text:=procname;
 tnew.base:=dbase;
 tnew.caption:=SRpProcedure+':'+procname+' - '+dbase.databasename;
 tnew.dbform:=self;
 tnew.fetchparams;
 tnew.acompile.enabled:=false;
 tnew.aexecute.enabled:=true;
end;

procedure TFDatabase.ShowRoleOps(role:string);
begin
 if Not Assigned(FRoleAccess) then
 begin
  Application.CreateForm(TFRoleAccess,FRoleAccess);
  fmain.DWindows.AppendRecord(
   [SRpRoleaccess,
   SrpWindow,BuildIBDatabaseName((Length(server)>0),protocol,server,filename),integer(FRoleAccess)]);
  FRoleAccess.base:=dbase;
  FROleaccess.user:=username;
  FRoleaccess.server:=server;
  FRoleaccess.password:=password;
  FRoleaccess.protocol:=protocol;
  FRoleAccess.OnDestroy:=FRoleAccessDestroy;
  FRoleAccess.Caption:=SrpAccesscontrol+' - '+dbase.DatabaseName;
 end;
 if Length(Trim(role))>0 then
 begin
  FRoleaccess.ComboShow.Itemindex:=1;
  FRoleaccess.ComboRole.text:=role;
  FRoleAccess.ComboRoleClick(Self);
 end
 else
  FRoleaccess.readall;
 FRoleAccess.Show;
end;

procedure TFDatabase.ARoleAccessExecute(Sender: TObject);
begin
 ShowRoleOps('');
end;

procedure TFDatabase.ACloseExecute(Sender: TObject);
begin
 Close;
end;

procedure TFDatabase.AMetadataExecute(Sender: TObject);
begin
 // Shows metadata dialog
 ShowIBExtract(dbase);
end;
procedure TFDatabase.ASystemdomainsExecute(Sender: TObject);
begin
 ASystemdomains.checked:=Not ASystemdomains.checked;
end;

 end.
