{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Delete database                                 }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit delbase;

interface

uses
  SysUtils, Classes, QForms,
  Db, IBDatabase,rpibdb, QDialogs, QStdCtrls, QButtons, QControls;

type
  TFDelbase = class(TForm)
    Label3: TLabel;
    EPassword: TEdit;
    EUsername: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    BSearch: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label6: TLabel;
    BDelete: TButton;
    BCancel: TButton;
    base: TIBDatabase;
    EBase: TEdit;
    LAlias: TLabel;
    BCOnfig: TBitBtn;
    ComboAlias: TComboBox;
    EServer: TEdit;
    ComboProtocol: TComboBox;
    LProtocol: TLabel;
    IBTransaction1: TIBTransaction;
    procedure BSearchClick(Sender: TObject);
    procedure EServerChange(Sender: TObject);
    procedure BDeleteClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboAliasClick(Sender: TObject);
    procedure BCOnfigClick(Sender: TObject);
  private
    { Private declarations }
    deleted:boolean;
    procedure deletebase;
  public
    { Public declarations }
    dbconf:TRpDBIBconf;
  end;


function DeleteDatabase(username,password:string;dbconf:TRpDBIBconf):boolean;

implementation

function DeleteDatabase(username,password:string;dbconf:TRpDBIBconf):boolean;
var
 dia:TFDelbase;
begin
 dia:=TFDelbase.Create(Application);
 try
  dia.EUsername.text:=username;
  dia.EPassword.text:=password;
  dia.dbconf:=dbconf;
  dia.showmodal;
  Result:=dia.deleted;
 finally
  dia.free;
 end;
end;

{$R *.xfm}

procedure TFDelbase.BSearchClick(Sender: TObject);
begin
 if opendialog1.execute then
  EBase.text:=opendialog1.filename;
end;

procedure TFDelbase.EServerChange(Sender: TObject);
begin
 if Length(Trim(Eserver.Text))>0 then
 begin
  LProtocol.Visible:=True;
  ComboProtocol.Visible:=True;
 end
 else
 begin
  LProtocol.Visible:=False;
  ComboProtocol.Visible:=False;
 end;
 if Length(trim(EServer.text))>0 then
  BSearch.visible:=false
 else
  BSearch.visible:=true;
end;

procedure TFDelbase.deletebase;
begin
 base.Params.clear;
 base.databasename:=BuildIBDatabaseName((Length(Trim(EServer.text))>0),TRpIBXProtocol(ComboProtocol.ItemIndex),EServer.Text,EBase.text);

 base.params.add('user_name='+EUsername.text);
 base.params.add('password='+EPassword.text);
 base.connected:=true;
 base.DropDatabase;
 base.connected:=false;
end;

procedure TFDelbase.BDeleteClick(Sender: TObject);
begin
 deletebase;
 deleted:=true;
 close;
end;

procedure TFDelbase.FormShow(Sender: TObject);
begin
 if Assigned(dbconf) then
 begin
  LAlias.visible:=True;
  Comboalias.visible:=True;
  BConfig.visible:=True;
  comboalias.Items.Assign(dbconf.databases);
 end;
 Comboalias.itemindex:=-1;
 ComboProtocol.itemindex:=0;
end;

procedure TFDelbase.ComboAliasClick(Sender: TObject);
var
 dbinfo:TRpDBIBinfo;
begin
 if Comboalias.itemindex<0 then
  exit;
 dbinfo:=dbconf.databases.items[comboalias.itemindex];
 EServer.text:=dbinfo.Server;
 EserverChange(Self);
 EBase.text:=dbinfo.Filename;
 EUsername.text:=dbinfo.username;
 EPassword.text:=dbinfo.password;
 ComboProtocol.Itemindex:=integer(dbinfo.protocol);
end;

procedure TFDelbase.BCOnfigClick(Sender: TObject);
begin
 dbconf.ShowConfig(True,True,true);
 dbconf.LoadAliases;
 comboalias.Items.Assign(dbconf.databases);
 comboalias.itemindex:=-1;
end;

end.
