{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Domain advanced info dialog                     }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit domadvanced;

interface

uses Classes, QForms, ibdatabase,ibutil2, Db,SysUtils,
  ibacutils, DBClient, QStdCtrls, QControls, QGrids, QDBGrids;

type
  TFDomadvanced = class(TForm)
    DDimensions: TClientdataset;
    DDimensionsLowIndex: TIntegerField;
    DDimensionsHighIndex: TIntegerField;
    DataSource1: TDataSource;
    GridArray: TDBGrid;
    LArray: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    LCheck: TLabel;
    Ecomputed: TEdit;
    EDefault: TEdit;
    ECheck: TEdit;
    CheckNoNull: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    LDescription: TLabel;
    LSize: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Lcollation: TLabel;
    Lcharset: TLabel;
    Label8: TLabel;
    DBGrid1: TDBGrid;
    DDepen: TClientdataset;
    DDepenTABLE: TStringField;
    DDepenFIELD: TStringField;
    DataSource2: TDataSource;
    EName: TEdit;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    base:TIBDatabase;
    domain:String;
    procedure Filldomaindetail(dia:TFFetching);
  public
    { Public declarations }
  end;

procedure ibshowdomain(base:TIBDatabase;domain:string);

implementation

{$R *.xfm}


procedure ibshowdomain(base:TIBDatabase;domain:string);
var
 dia:TFDomadvanced;
begin
 dia:=TFDomadvanced.create(Application);
 try
  dia.base:=base;
  dia.domain:=domain;
  ExecuteActionProgres(dia.Filldomaindetail,true,nil);
 except
  dia.free;
 end;
end;

procedure TFDomadvanced.Filldomaindetail(dia:TFFetching);
var
 i:integer;
 dinfo:TIBDefdomain;
begin
 try
  dinfo:=FillDomaininfo(base,domain,dia);
  ECheck.text:=dinfo.check;
  EDefault.text:=dinfo.default;
  EComputed.text:=dinfo.computed;
  Checknonull.Checked:=dinfo.Notnull;
  Lcharset.caption:=dinfo.character_set;
  LCollation.caption:=dinfo.character_set;
  LSize.caption:=inttostr(dinfo.sizebytes);
  DDimensions.disablecontrols;
  try
   EName.text:=dinfo.name;
   LDescription.Caption:=ibfieldtypetosource(dinfo.basetype,dinfo.size,dinfo.scale,base.sqldialect);
   for i:=0 to dinfo.arraydimcount-1 do
   begin
    DDimensions.Append;
    try
     DDimensionsLowIndex.Value:=dinfo.arraydim[i].low;
     DDimensionsHighIndex.Value:=dinfo.arraydim[i].high;
     DDimensions.post;
    except
     DDimensions.cancel;
     raise;
    end;
   end;
   Filldomaindepen(base,domain,ddepen,dia);
  finally
   DDimensions.EnableControls;
  end;
  ShowModal;
 except
  free;
  Raise;
 end;
end;


procedure TFDomadvanced.FormCreate(Sender: TObject);
begin
 DDepen.CreateDataSet;
 DDimensions.createdataset;
end;
 end.
