{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Fetch progres for querys and utils              }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit ibacutils;

interface

uses
  SysUtils, Classes,QForms,
  ibacconst,rpshfolder,IBDatabase,ibsql, db, QStdCtrls, QControls;


type
  TBeforePostEvent=procedure (IBSQL:TIBSQL;datas:TDataset) of object;

  TFFetching = class;

  TExecutePEvent=procedure (Dia:TFFetching) of object;
  TExecutePEndEvent=procedure of object;

  TFFetching = class(TForm)
    BCancel: TButton;
    Label1: TLabel;
    LRows: TLabel;
    procedure BCancelClick(Sender: TObject);
  private
    { Private declarations }
    beforepost:TBeforePostEvent;
    procedure AppIdle(Sender:TObject;Var done:Boolean);
    procedure AppIdleAction(Sender:TObject;Var done:Boolean);
    procedure DoFill;
  public
    { Public declarations }
   cancel:boolean;
   IBCustom:TIBSQL;
   Trans:TIBTransaction;
   sql:string;
   dataset:TDataset;
   autoclose:boolean;
   acount:integer;
   OnExecute:TExecutePEvent;
   procedure IncFetch(increment:integer);
  end;


function CreateFormAndShow(Form1:TFormclass):TModalresult;
procedure FillDataset(IBCustom:TIBSQL;Trans:TIBTransaction;sql:string;dataset:TDataset;BeforePost:TBeforePostEvent);

procedure ExecuteActionProgres(OnExecute:TExecutePEvent;autoclose:boolean;EndEvent:TExecutePEndEvent);

implementation

{$R *.xfm}

procedure TFFetching.IncFetch(increment:integer);
begin
 acount:=acount+increment;
 LRows.Caption:=FormatFloat('#,##0',acount);
 Application.processmessages;
 if cancel then
  Raise Exception.Create(SRpOperationAborted);
end;

function CreateFormAndShow(Form1:TFormclass):TModalresult;
var
 dia:TForm;
begin
 dia:=form1.Create(Application);
 try
  Result:=dia.ShowModal;
 finally
  dia.free;
 end;
end;

procedure FillDataset(IBCustom:TIBSQL;Trans:TIBTransaction;sql:string;dataset:TDataset;BeforePost:TBeforePostEvent);
var
 dia:TFFetching;
 oldappidle:TIdleevent;
begin
 dia:=TFFetching.create(Application);
 try
  dia.trans:=Trans;
  dia.ibcustom:=ibcustom;
  dia.sql:=sql;
  dia.dataset:=dataset;
  dia.beforepost:=beforepost;
  oldappidle:=Application.onidle;
  try
   Application.OnIdle:=dia.AppIdle;
   dia.showmodal;
  finally
   Application.onidle:=oldappidle;
  end;
 finally
  dia.free;
 end;
end;

procedure TFFetching.AppIdle(Sender:TObject;Var done:Boolean);
begin
 application.onidle:=nil;
 done:=False;
 try
  DoFill;
 finally
  Close;
 end;
end;

procedure TFFetching.DoFill;
var
 counter:integer;
 i:integer;
begin
 counter:=0;
 Trans.StartTransaction;
 try
  IBCustom.Close;
  IbCustom.SQL.text:=SQL;
  IBCustom.ExecQuery;
  try
   dataset.disablecontrols;
   try
    While Not IBCustom.EOF do
    begin
     dataset.Append;
     try
      if not assigned(beforepost) then
      begin
       for i:=0 to ibcustom.current.count-1 do
       begin
        if dataset.Fields[i].DataType in [ftstring,ftMemo] then
         dataset.fields[i].Value:=ibcustom.fields[i].AsString
        else
         dataset.fields[i].Value:=ibcustom.fields[i].Value;
       end;
      end
      else
       beforepost(ibcustom,dataset);
      dataset.post;
     except
      dataset.cancel;
      raise;
     end;
     inc(counter);
     LRows.Caption:=FormatFloat('#,##0',counter);
     Application.processmessages;
     if cancel then
      Raise Exception.create(SRpOperationAborted);
     IBCustom.Next;
    end;
    dataset.first;
   finally
    dataset.enablecontrols;
   end;
  finally
   IBCustom.close;
  end;
  Trans.Commit;
 except
  Trans.Rollback;
  Raise;
 end;
end;

procedure TFFetching.BCancelClick(Sender: TObject);
begin
 cancel:=True;

end;

procedure ExecuteActionProgres(OnExecute:TExecutePEvent;autoclose:boolean;EndEvent:TExecutePEndEvent);
var
 dia:TFFetching;
 oldappidle:TIdleevent;
begin
 try
  dia:=TFFetching.create(Application);
  try
   oldappidle:=Application.onidle;
   try
    Application.OnIdle:=dia.AppIdleAction;
    dia.autoclose:=autoclose;
    dia.onexecute:=onexecute;
    dia.showmodal;
   finally
    Application.onidle:=oldappidle;
   end;
  finally
   dia.free;
  end;
 finally
  if Assigned(EndEvent) then
   EndEvent;
 end;
end;

procedure TFFetching.AppIdleAction(Sender:TObject;Var done:Boolean);
begin
 application.onidle:=nil;
 done:=False;
 try
  if Assigned(OnExecute) then
   OnExecute(Self);
 finally
  if autoclose then
   Close;
 end;
end;

end.
