{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       New blob filter                                 }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit newblobfilter;

interface

uses Classes, QForms,SysUtils,
 ibdatabase,ibutil2, QMask, QStdCtrls, QControls;

type
  TFNewBlobFilter = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    EModule: TEdit;
    Label2: TLabel;
    EEntrypoint: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    EInput: TMaskEdit;
    EOutput: TMaskEdit;
    EFilter: TEdit;
    Label5: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    docreate:boolean;
    base:TIBDatabase;
  public
    { Public declarations }
  end;

procedure IBDropBlobFilter(base:TIBDatabase;filter:string);
function IBNewBlobFilter(base:TIBDatabase):boolean;

implementation

{$R *.xfm}
procedure IBDropBlobFilter(base:TIBDatabase;filter:string);
var
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 IBExecuteSQL(base,'DROP FILTER '+adeli+filter+adeli);
end;

function IBNewBlobFilter(base:TIBDatabase):boolean;
var
 dia:TFNewBlobFilter;
begin
 dia:=TFNewBlobFilter.create(Application);
 try
  dia.base:=base;
  Result:=dia.showmodal=mrok;
 finally
  dia.free;
 end;
end;


procedure TFNewBlobFilter.OKBtnClick(Sender: TObject);
begin
 docreate:=true;
end;

procedure TFNewBlobFilter.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
 adeli:string;
begin
 adeli:='';
 if base.sqldialect=3 then
  adeli:='"';
 try
  if docreate then
  begin
   IBExecuteSQL(base,'DECLARE FILTER '+adeli+EFilter.text+adeli+' INPUT_TYPE '+
    EInput.text+' OUTPUT_TYPE '+EOutput.text+' ENTRY_POINT '+
    QuotedStr(EEntrypoint.text)+' MODULE_NAME '+QuotedStr(EModule.text));
  end;
 finally
  docreate:=false;
 end;
end;

end.
