{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       New database shadow dialog                      }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit newshadow;

interface

uses
  SysUtils, Classes,
  Db, ibacconst, QMask,QForms,variants,
  DBClient, QStdCtrls,  QExtCtrls, QControls, QGrids, QDBGrids;

type
  TFNewShadow = class(TForm)
    BOK: TButton;
    BCancel: TButton;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Label1: TLabel;
    RAutoman: TRadioGroup;
    CheckCond: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    LServer: TLabel;
    LBase: TLabel;
    DSecond: TClientdataset;
    DSecondFile: TStringField;
    DSecondSize: TIntegerField;
    DSecondSizeMb: TIntegerField;
    EIden: TMaskEdit;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BOKClick(Sender: TObject);
    procedure DSecondCalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    docreate:boolean;
    pagesize:integer;
  end;


implementation

{$R *.xfm}

procedure TFNewShadow.FormShow(Sender: TObject);
begin
 DSecond.Createdataset;
end;

procedure TFNewShadow.FormCreate(Sender: TObject);
begin
 docreate:=false;
end;

procedure TFNewShadow.BOKClick(Sender: TObject);
var
 i:integer;
begin
 DSecond.checkbrowsemode;
 if DSecond.EOF and DSecond.BOF then
  Raise Exception.create(SRpAtLeastOne);
 DSecond.first;
 for i:=1 to DSecond.RecordCount-1 do
 begin
  if DSecondSize.isnull then
   Raise exception.Create(SRpSpecsize);
  DSecond.next;
 end;
 DSecond.Last;
 DSecond.edit;
 DSecondsize.AsVariant:=null;
 DSecond.post;
 docreate:=true;
 close;
end;

procedure TFNewShadow.DSecondCalcFields(DataSet: TDataSet);
begin
 if pagesize=0 then
  exit;
 if DSecondsize.isnull then
  DSecondsizemb.asvariant:=null
 else
  DSecondsizemb.asinteger:=DSecondsize.asinteger*(pagesize div 1024) div 1024;
end;

end.
