{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Create view dialog                              }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit newview;

interface

uses Classes, QForms,SysUtils,
  IBSQL, IBDatabase, ibacconst, QStdCtrls, QControls;

type
  TFNewView = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Trans: TIBTransaction;
    IBSQL1: TIBSQL;
    Label1: TLabel;
    MColumns: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    EName: TEdit;
    MCheckOption: TCheckBox;
    MEdit: TMemo;
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
    procedure CreateView;
  public
    { Public declarations }
    base:TIBDatabase;
    docreate:boolean;
  end;


function IBCreateView(base:TIBDatabase):boolean;

implementation

{$R *.xfm}
function IBCreateView(base:TIBDatabase):boolean;
var
 dia:TFNewView;
begin
 dia:=TFNewView.Create(Application);
 try
  dia.base:=base;
  dia.EName.text:='NEWVIEW';
  dia.ShowModal;
  Result:=dia.docreate;
 finally
  dia.free;
 end;
end;

procedure TFNewView.CreateView;
var
 astring:string;
begin
 if Length(Trim(EName.text))<1 then
  Raise Exception.Create(SRpViewMusthavename);
 trans.defaultdatabase:=base;
 IBSQL1.Database:=base;
 trans.starttransaction;
 try
  astring:='CREATE VIEW "'+EName.Text+'"';
  if Length(Trim(MColumns.text))>0 then
   astring:=astring+' ('+MColumns.text+') ';
  astring:=astring+' AS '+MEdit.text;
  if MCheckOption.checked then
   astring:=astring+ ' WITH CHECK OPTION ';
  IBSQL1.sql.text:=astring;
  IBSQL1.ExecQuery;
  trans.commit;
 except
  trans.rollback;
  raise;
 end;
end;

procedure TFNewView.OKBtnClick(Sender: TObject);
begin
 CreateView;
 Close;
 docreate:=true;
end;

end.
