{*******************************************************}
{                                                       }
{       IBAccess                                        }
{       Table dependences dialog                        }
{                                                       }
{       Author:                                         }
{       Toni Martir                                     }
{       http://www.ibaccess.org                         }
{       e-mail: toni@pala.com                           }
{                                                       }
{       OpenSource license (MPL)                        }
{                                                       }
{*******************************************************}

unit tabledepen;

interface

uses Classes, QForms,
  ibdatabase,ibacutils,ibutil2, Db,
  ibacconst, DBClient, QStdCtrls, QControls, QExtCtrls, QGrids, QDBGrids;

type
  TDepentype=(depentable,depenview,depenproc,depenexcept);
  TFTabledepen = class(TForm)
    DMem: TClientdataset;
    DMemDepenname: TStringField;
    DMemDepentype: TStringField;
    DMemDepenfield: TStringField;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Label1: TLabel;
    EObject: TEdit;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    table:string;
    base:TIBDatabase;
    procedure Filltable(dia:TFFetching);
  public
    { Public declarations }
  end;

procedure ibshowtabledepen(base:TIBDatabase;table:string;dtype:TDepentype);

implementation

{$R *.xfm}

procedure ibshowtabledepen(base:TIBDatabase;table:string;dtype:TDepentype);
var
 dia:TFTabledepen;
begin
 dia:=TFTabledepen.create(Application);
 try
  dia.base:=base;
  dia.table:=table;
  dia.eobject.text:=table;
  case dtype of
   depenview:
    dia.caption:=SRpViewDependences;
   depenproc:
    dia.caption:=SRpProcDependences;
   depenexcept:
    dia.caption:=SRpExcepDependences;
  end;
  ExecuteActionProgres(dia.Filltable,true,nil);
  dia.showmodal;
 except
  dia.free;
 end;
end;

procedure TFTabledepen.Filltable(dia:TFFetching);
begin
 dmem.disablecontrols;
 try
  FillTableDepen(base,table,dmem,dia);
  dmem.first;
 finally
  dmem.enablecontrols;
 end;
end;

procedure TFTabledepen.FormCreate(Sender: TObject);
begin
 DMem.createdataset;
end;

end.
